:: -------------------------------------------------------------------
:: 
:: Createmultixpi.bat download and pack in a multi xpi file  Firefox and Thunderbird extensions that are located to addons.mozilla.org
::                 within the cmd console of windows XP
:: 
:: author : Sandro Della Giustina (gialloporpora) http://www.gialloporpora.netsons.org
:: date   : June 28, 2008
:: version: 0.1
::
:: Copyright (c) 2007 by Sandro Della Giustina (gialloporpora)
::
:: -------------------------------------------------------------------
::
:: Permission is granted to copy, distribute and/or modify this document
:: under the terms of the GNU Free Documentation License, Version 1.2
:: or any later version published by the Free Software Foundation;
:: with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
:: Texts.  A copy of the license is included in the file LICENSE.TXT
::
::  Credits:
:: GEtgnuwin32 for the idea of creating a BATCH file to download packages
:: http://getgnuwin32.sourceforge.net/
:: miki64  to have told me as to create a multi XPI package:
:: http://forum.extenzilla.org/index.php?action=printpage;topic=3860.0
:: klades to have created the trick and for many good extension  (unfortunately, these extensions are not hosted on AMO and this script does't work with them):
:: http://nic-nac-project.de/~kaosmos/index.html


@echo off
:: Set the PATH where to find the Gnuwin32 commands used in this script (sed, wget and zip)
:: If you have already added this folder to you system variables, simply uncomment the following line
:: PATH=%PATH%;%PROGRAMFILES%\gnuwin32\bin\
:: If no parameters are passed as commanline arguments, the execution is blocked
IF "%1"=="" GOTO no_parameters
IF NOT EXIST %1 GOTO file_not_exist



:: Before downloading new extensions we remove all old XPI file in the working directory multixpi
IF EXIST multixpi\*.xpi del multixpi\*.xpi
:: To prevent errors caused by previous undeletion of temp files, we check if  temp files exist and delete  them
IF EXIST download.temp del download.temp


:: Now, we start to read the MXPI file and downloading  the  HTML of their webpages, first we'll remove all  unnecessarycomment
sed -n -e "/^https:\/\/addons\.mozilla.*/p" %1 > mxpifile.temp
:: If this first call to sed cause  an error, it means that the gnuwin32 tools are not
:: visible from the working folder. 
IF ERRORLEVEL 1 goto not_installed
:: Now we parse the MXPI file, download the page of the extension and put the direct link to XPI file in  download.temp file.
FOR /F  %%f  in (mxpifile.temp) DO (
    wget %%f --no-check-certificate  --no-cache  --output-document=file.temp
    sed -n -f findxpi.sed file.temp >> download.temp
    del file.temp
)
CD multixpi

:: Now, we parse the file download.temp that contains the direct link to XPI file and download them

FOR /F %%f in (..\download.temp) DO wget "%%f" --no-check-certificate --no-cache

:: Creating the ZIP (XPI) package of the multixpi extension.
zip multixpi.xpi *.*
:: If you prefere to use 7-Zip to compress files in the ZIP archive (like me too),  remove the  previous line and uncomment the next line. Probablly you need to add the 7-ZIP folder  to PATH.
:: 7z a -txpi multixpi.xpi  *.*

CD ..
move multixpi\multixpi.xpi
:: Delete temp files
del *.temp
goto bye


:no_parameters
echo ERROr !!!
echo You need to specify a MXPI file as parameter.
goto help_message

:file_not_exist
echo ERROR !!!
echo Sorry, the MXPI file not exist. Please try with a valid MXPI file.
goto help_message



:help_message
echo ---------  USAGE -------------
echo createmultixpi example.mxpi
echo ------------------------------
echo The  MXPI file must contains the URL of the extension's webpage at addons.mozilla.org
echo Open the file default.mxpi for an example of valid mxpi syntax.
echo Please, make sure that no blank lines are in this file.
goto bye

:not_installed
echo ERROR !!!
echo It is impossible to run sed and the other gnuwin32  executables.
echo Please install them before executing this script. Running the file install.bat in this folder could be solve this issue. 




:bye